<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] ?: array()) + array("_a7ed4d7408bb99b87a" . "09d89d4212d5de" => base64_decode("c2ltcGxlX2FjbA=" . "="), "_0877a0b48cf424a0de57a453c" . "e95e30c" => base64_decode("aW50OnVzZXJfaWQ" . "="), "_b06968b9268deaf3b380bd0fe922b" . "453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX" . "2FjbCBXSEVSRSBvYmplY3RfY2" . "9kZSBlcTpzdHI6Y29kZSBBTkQ" . "gdXNlcl9pZD1pbnQ6dWlk"), "_a8b22fedb27a11e07f5bb9a7c73608" . "ea" => base64_decode("c3RyKDEwMCk6b2JqZWN0" . "X2NvZGU="), "_84718d828d2acc3c3" . "66f96b07e841f6a" => base64_decode("YWNsLn" . "NpbXBs" . "ZQ=="), "_27de5a45db71bf24058769b" . "61b3975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0" . "w6IG9iamVjdCBjb2Rl" . "IG5vdCBzcGVjaWZpZW" . "Q="), "_c95cbc316178c97697a403" . "f4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9" . "NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2" . "NvZGUgZXE6c3RyOmNvZGU="), "_ef2948c87ef38aab9226e41189b" . "29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y2" . "9kZQ=="), "_938704c" . "4c0169c3" . "804d4bd6" . "aa9941a7" . "6" => base64_decode("Q2FuJ3QgbG9hZCBB" . "Q0w6IG9iamVjdCBj" . "b2RlIG5vdCBzcGVj" . "aWZpZWQ="), "_dbbe14f567693a631f8a43b65af91" . "7ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNlO" . "iBvYmplY3QgY29kZSBub3Qgc3BlY2lmaWVk"), "_80fc2a45acd0150df87d1fb728" . "940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVzZXJfaWQ9aW50OnVpZA" . "=="), "_3cda3f34ada928e4aa" . "39d4629c5504aa" => base64_decode("aW50O" . "nJpZ2" . "h0cw=" . "="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_84718d828d2ac" . "c3c366f96b07e8" . "41f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_80fc2a45acd0150df87d1fb72" . "8940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_a7ed4d7408bb99b87a09d" . "89d4212d5de"], [$GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_a8b22fedb27a11e07f5bb9a7c736" . "08ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_0877a0b48cf424a0de57a4" . "53ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_3cda3f34" . "ada928e4a" . "a39d4629c" . "5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_b06968b9268deaf3b3" . "80bd0fe922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_938704c4c0169c3804d4bd" . "6aa9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1e" . "c2d6653e8a" . "0ab7848e53" . "6215"]["_c95cbc316178c97697a" . "403f4d9124106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_27de5a45db71bf24058769b61b3975" . "a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_dbbe14f567693a631f8a43b65af" . "917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_ef2948c87ef3" . "8aab9226e4118" . "9b29ca7"], $acl->GetObjectCode());
    }
}